function Contador() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Contábil', 'Contador']);
		geral.esperarLoading();
		z.component.footer.clickRightActionByLabel('Filtrar', true);
	};

	this.adicionar = (codigo, nome, cpf, telefone, ramal, email, cep, estadoEmissaoCRC,
		registroCRC, numeroCRP, anoEmissaoCRP, dataVencimentoCRP, estadoEmissaoCRP) => {
		geral.clickAndFillFields('CDCONTADOR2', codigo,
			'NMCONTADOR', nome,
			'NRINSJURCONT', cpf,
			'NRTELCONTATO', telefone,
			'NRRAMALCONTA', ramal,
			'DSENDINTERN', email,
			'NRCEP', cep,
			'NRCRCCONT2', registroCRC,
			'NRANOCRP', anoEmissaoCRP,
			'NRREGCRP', numeroCRP,
			'DTVENCCRP', dataVencimentoCRP);
		geral.searchAndClickGridFields('NMESTADOCRC', estadoEmissaoCRC, 'NMESTADO',
			'NMESTADOCRP', estadoEmissaoCRP, 'NMESTADO');
	};

	this.editar = (nome, cpf, telefone, ramal, email, cep, estadoEmissaoCRC, registroCRC,
		numeroCRP, anoEmissaoCRP, dataVencimentoCRP, estadoEmissaoCRP) => {
		geral.fillFields('NMCONTADOR', nome,
			'NRINSJURCONT', cpf,
			'NRTELCONTATO', telefone,
			'NRRAMALCONTA', ramal,
			'DSENDINTERN', email,
			'NRCEP', cep,
			'NRCRCCONT2', registroCRC,
			'NRANOCRP', anoEmissaoCRP,
			'NRREGCRP', numeroCRP,
			'DTVENCCRP', dataVencimentoCRP);
		geral.clickLimparAutoComplete('NMESTADOCRC');
		geral.clickLimparAutoComplete('NMESTADOCRP');
		geral.searchAndClickGridFields('NMESTADOCRC', estadoEmissaoCRC, 'NMESTADO',
			'NMESTADOCRP', estadoEmissaoCRP, 'NMESTADO');
	};
}

module.exports = new Contador();
